﻿var pne = pne||{};

(function (pne) {
	
   var EnergyBar = (function () {
        function EnergyBar(is_n_energy, x,bottom_y,top_y,index) {
        	this._value				= 0;
          this._dirty 			= true;
        	this.is_n_energy 	= is_n_energy;
        	this.x = x;
        	this.y = bottom_y;
        	this.percent 	= 0;
        	this.bottom_y = bottom_y;
        	this.top_y 		= top_y;

        	this.head 		= cph5.RES.getRes((is_n_energy ? "head_n_" : "head_p_") + index);
        	this.head_index = index;
          
        	this.body 		= cph5.RES.getRes((is_n_energy ? "head_n_1" : "head_p_1"));
       		this.body_sx 	= 67;
       		this.body_sy 	= 116;
       		this.body_sw 	= 46;
       		this.body_sh 	= 1;
       		this.body_dw 	= 46;
       		
        	this.button 		= cph5.RES.getRes((is_n_energy ? "button_n_1" : "button_p_1"));
        	this.button_x		= is_n_energy ? 85 : 289;
        	this.button_y		= 660;
       		
       		this.clickable	= true;
       		this.clicktime	= Date.now();
       		this.inTick			= false;
        }
        
				EnergyBar.prototype.onUpdate = function(delta) {
					if (this.inTick && this.head_index != 2) {
						if (Date.now()-this.clicktime >= 200)
							this.setImage(2);
					}
				}
				
				EnergyBar.prototype.onTouchBegan = function(x, y) {

					this.setButton(1);
					
					if (!this.clickable)
						return false;
						
					if (x > this.button_x && y>this.button_y && x<this.button_x+106 && y<this.button_y+106) {
						this.setButton(2);
						return true;
					}
					
					return false;
				}
				
				EnergyBar.prototype.onTouchEnd = function(x, y) {
					this.setButton(1);
					
					if (!this.clickable)
						return false;
						
					if (!(x > this.button_x && y>this.button_y && x<this.button_x+106 && y<this.button_y+106))
							return false;

					this.clicktime	= Date.now();
					this.inTick			= true;
					
					var index = 1;
					if (this.percent >= 1.0)
							index = 4;
					else if (this.head_index == 1)
						index = 3;
					
					this.setImage(index);
					this._dirty = true;
					
					return true;
				};


				EnergyBar.prototype.setImage = function(index) {
					if (this.head_index != index) {
						this.head_index = index;
						this.head = cph5.RES.getRes((this.is_n_energy ? "head_n_" : "head_p_") + index);
						this._dirty = true;
					}
				};
				
				EnergyBar.prototype.setButton = function(index) {
					this.button = cph5.RES.getRes((this.is_n_energy ? "button_n_" : "button_p_") + index);
					this._dirty = true;
				};
				
				EnergyBar.prototype.setProgress = function(percent) {
					if (percent < 0) percent = 0; 
					else if (percent > 1.0) percent = 1.0;
					this.percent = percent;
					
					var y = (this.top_y-this.bottom_y)*percent + this.bottom_y;
					if (this.y != y) {
						this.y = y;
						this._dirty = true;
					}
				};
				
				EnergyBar.prototype.draw = function(context) {
					context.drawImage(this.button, this.button_x, this.button_y);

					context.drawImage(this.body, this.body_sx, this.body_sy, this.body_sw, this.body_sh, 
																			 this.x+this.body_sx, this.y+this.body_sy, this.body_dw, this.bottom_y-this.y);					

					context.drawImage(this.head, this.x, this.y);

					this._dirty = false;
				};

        return EnergyBar;
    })();
    
    pne.EnergyBar = EnergyBar;
    EnergyBar.prototype.__class__ = "pne.EnergyBar";
    
})(pne);
