﻿var cph5 = cph5 || {};

(function (cph5) {
	
    var Label = (function () {
        function Label(font, color, x, y, text, align) {
        		this.x = x;
        		this.y = y;
        		this._align = align;
            this._text = text;
            this._style = color;
            this._font 	= font;
            this._dirty = true;
        }
        
        Label.prototype.draw = function (context) {
		        context.fillStyle 		= this._style;
		        context.font 					= this._font;
		        context.textBaseline	= 'middle';
		        
		        var x = 0;
		        if (this._align == "left") {
		        	x = this.x;
		        } else if (this._align == "right") {
			        var width = context.measureText(this._text).width;
		        	x = this.x - width;
		        } else {
			        var width = context.measureText(this._text).width;
		        	x = this.x - width/2.0;
		        }
		        context.fillText(this._text, x, this.y);
		        this._dirty = false;
				}

        Label.draw = function (context, font, color, x, y, text, align, baseline) {
		        context.fillStyle 		= color;
		        context.font 					= font;
		        context.textBaseline	= baseline||'middle';
		        
		        if (align == "left") {
		        } else if (align == "right") {
			        var width = context.measureText(text).width;
		        	x -= width;
		        } else {
			        var width = context.measureText(text).width;
		        	x -= width/2.0;
		        }
		        context.fillText(text, x, y);
				}
				
        Label.prototype.setString = function (text) {
        		if (this._text != text) {
           		this._text 	= text;
            	this._dirty = true;
          	}
        };
        
        Label.prototype.getWidth = function (context) {
		        context.fillStyle 		= this._style;
		        context.font 					= this._font;
		        context.textBaseline	= 'middle';
		        
		        var width = context.measureText(this._text).width;
		        return width;
				}
        
        return Label;
    })();
    cph5.Label = Label;
    Label.prototype.__class__ = "cph5.Label";
    
})(cph5);
