﻿var pne=pne||{};

(function (pne) {
	
   var FloatText = (function () {
        function FloatText(label, x, y) {
          this._dirty 	= true;
        	this.x 				= x;
        	this.y 				= y;
					this.alpha		= 0.0;
					this._scale		= 1.0;
					this._dAlpha	= 0;
					this._tAlpha	= 0;
					this._fadeTo	= this.alpha;
					this._dMoveX	= 0;
					this._dMoveY	= 0;
					this._tMove 	= 0;
					this._moveToX	= this.x;
					this._moveToY	= this.y;
					this._scaleTo	= 1.0;
					this._dScale	= 0;
					this._tScale	= 0;
					this.label 		= label;
        }
        
				FloatText.prototype.fadeTo = function(time, alpha) {
					this._fadeTo		= alpha;

					if (time <= 0) {
						this.alpha 		= alpha;
						this._dAlpha	= 0;
						this._tAlpha	= 0;
						return;
					}
					
					this._dAlpha		= (alpha-this.alpha)/time;
					this._tAlpha		= time;
      	}
      	
				FloatText.prototype.stopFadeTo = function() {
					this._fadeTo	= this.alpha;
					this._dAlpha	= 0;
					this._tAlpha	= 0;
				}      	
      	
				FloatText.prototype.scaleTo = function(time, scale) {
					this._scaleTo		= scale;

					if (time <= 0) {
						this._scale 		= scale;
						this._dScale	= 0;
						this._tScale	= 0;
						return;
					}
					
					this._dScale		= (scale-this._scale)/time;
					this._tScale		= time;
      	}
        
				FloatText.prototype.stopScaleTo = function() {
					this._scaleTo	= this._scale;
					this._dScale	= 0;
					this._tScale	= 0;
				}
      	
				FloatText.prototype.moveTo = function(time, x, y) {
					this._moveToX	= x;
					this._moveToY	= y;

					if (time <= 0) {
						this.x = x;
						this.y = y;
						this._dMoveX	= 0;
						this._dMoveY	= 0;
						this._tMove 	= 0;
						return;
					}
					
					this._dMoveX	= (x-this.x)/time;
					this._dMoveY	= (y-this.y)/time;
					this._tMove		= time;
      	}
				
				FloatText.prototype.stopMoveTo = function() {
					this._moveToX	= this.x;
					this._moveToY	= this.y;
					this._dMoveX	= 0;
					this._dMoveY	= 0;
					this._tMove 	= 0;
      	}
      	
				FloatText.prototype.onUpdate = function(delta) {
					if (this._tMove > 0) {
						if (this._dMoveX != 0) {
							this.x += this._dMoveX*delta;
							this._dirty = true;
						}
						if (this._dMoveY != 0) {
							this.y += this._dMoveY*delta;
							this._dirty = true;
						}
						this._tMove -= delta;
					} else {
							this.x = this._moveToX;
							this.y = this._moveToY;
					}
					
					if (this._tAlpha > 0) {
						if (this._dAlpha != 0) {
							this.alpha += this._dAlpha*delta;
							this._dirty = true;
						}
						this._tAlpha -= delta;
					} else {
						this.alpha = this._fadeTo;
					}

					
					if (this._tScale > 0) {
						if (this._dScale != 0) {
							this._scale += this._dScale*delta;
							this._dirty = true;
						}
						this._tScale -= delta;
					} else {
						this._scale = this._scaleTo;
					}
      	}
      	
				FloatText.prototype.draw = function(context) {
					if (this.alpha <= 0)
						return;
					
					this.label.x = this.x/this._scale;
					this.label.y = this.y/this._scale;

          context.save();

					context.globalAlpha = this.alpha;

					context.scale(this._scale,this._scale);
					this.label.draw(context);
					
					context.restore();
					
        	this._dirty = false;
				};
        
			
				FloatText.prototype.setPosition = function(x,y) {
        	this.x = x;
        	this.y = y;
        	this._dirty = true;
				};

        return FloatText;
    })();
    
    pne.FloatText = FloatText;
    FloatText.prototype.__class__ = "pne.FloatText";
    
})(pne);
